package com.hys.app.model.erp.dto;

import com.hys.app.model.erp.enums.MsgTypeEnum;
import com.hys.app.model.erp.vo.SmsMailTemplateVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;


/**
 * 短信模板实体
 *
 * @author zhangsong
 * @version v1.0
 * @since v7.3.0
 * 2021-01-26 16:04:22
 */
@Data
public class BandTemplateDTO {

    @NotEmpty
    List<SmsMailTemplateVO> vos;

    private Long companyId;
}