package com.hys.app.model.erp.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 部门表
 */
@TableName(value = "erp_company_band_msg")
@Data
public class CompanyBandMsg  implements Serializable {

    public static final Long ROOT_ID = 0L;

    private Long id;
    /**
     * 公司id
     */
    private Long companyId;
    /**
     * 模板id
     */
    private Long templateId;
    /**
     * 自定义模板code
     */
    private String templateCode;

    @ApiModelProperty("是否勾选")
    private Boolean hasSelect;
}
